From a47d59c8abaedbe41cb03481aa6001dec61502d2 Mon Sep 17 00:00:00 2001
From: MatheusMello <mat.mello93@gmail.com>
Date: Oct 17 2017 18:53:49 +0000
Subject: [PATCH 6/6] Analysis Page and Search


Signed-off-by: Matheus Mello <mat.mello93@gmail.com>
Signed-off-by: rafaelrabetti <rafael.rabetti@gmail.com>
Signed-off-by: Eduardo Gomes <eduardoqgomes@gmail.com>
Signed-off-by: Thiago Moreira <thiago.cmoreira@yahoo.com.br>
Signed-off-by: Maxwell Oliveira <maxwell_oliveira2@hotmail.com>
Signed-off-by: Matheus Godinho <matheus.godinho@outlook.com>
Signed-off-by: Omar Junior <omarfariajr@gmail.com>
Signed-off-by: Eduardo Nunes <eduardonunes2525@gmail.com>

---

diff --git a/.gitignore b/.gitignore
index 74f8033..f14e4e1 100644
--- a/.gitignore
+++ b/.gitignore
@@ -5,6 +5,8 @@ npm-debug.log*
 yarn-debug.log*
 yarn-error.log*
 test/unit/coverage
+*lock.json
+package-lock.json
 
 # Editor directories and files
 .idea
diff --git a/src/api/index.js b/src/api/index.js
index 7982ba4..c71f91d 100644
--- a/src/api/index.js
+++ b/src/api/index.js
@@ -2,7 +2,7 @@ import axios from 'axios'
 
 let axiosApi = axios.create({
   baseURL: 'http://localhost:5000',
-  timeout: 1000
+  timeout: 3000
 })
 
 export default axiosApi
diff --git a/src/components/home/Home.vue b/src/components/home/Home.vue
index 29c3971..7a37d39 100644
--- a/src/components/home/Home.vue
+++ b/src/components/home/Home.vue
@@ -1,19 +1,23 @@
 <template>
   <div>
+    <search></search>
     <list-packages></list-packages>
   </div>
 </template>
 
 <script>
-import List from '../packages/List.vue'
+import List from '../package/List.vue'
+import Search from '../package/Search.vue'
 
 export default {
   name: 'home',
   components: {
+    'search': Search,
     'list-packages': List
   }
 }
 </script>
 
 <style lang="scss" scoped>
+
 </style>
diff --git a/src/components/package/List.vue b/src/components/package/List.vue
new file mode 100644
index 0000000..063edc1
--- /dev/null
+++ b/src/components/package/List.vue
@@ -0,0 +1,128 @@
+<template>
+  <div class="container list-pkgs">
+    <div class="row">
+      <div class="col-md-12">
+        <div class="alert">
+          <b-alert :show="sucessCountDown"
+                   dismissible
+                   variant="success"
+                   @dismissed="sucessCountDown=0"
+                   @dismiss-count-down="successCountDownChanged">
+            Packages successfully imported! ({{sucessCountDown}})
+          </b-alert>
+          <b-alert :show="errorCountDown"
+                   dismissible
+                   variant="danger"
+                   @dismissed="errorCountDown=0"
+                   @dismiss-count-down="errorCountDownChanged">
+            Packages not imported! ({{errorCountDown}})
+          </b-alert>
+        </div>
+      </div>
+    </div>
+
+    <div class="row table-meta-data">
+      <div class="col-md-5">
+        <b-button :disabled="disabled" variant="outline-primary sm" v-if="notUpdating" @click="this.updateTable"><icon name="refresh" scale="1.5"></icon> &nbsp &nbsp Update Table</b-button>
+        <b-button :disabled="disabled" variant="primary sm" v-else><icon spin name="refresh" scale="1.5"></icon> &nbsp &nbsp Updating</b-button>
+        <span class="date text-muted">Last updated {{ this.updateData }}</span>
+      </div>
+    </div>
+    <b-table striped hover :items="allPackages" height="100" @row-clicked="showPackage"></b-table>
+  </div>
+</template>
+
+<script>
+import { mapActions, mapGetters } from 'vuex'
+import * as actionTypes from '../../store/actionTypes.js'
+import * as getterNames from '../../store/getterNames.js'
+import moment from 'moment'
+
+export default {
+  data () {
+    return {
+      updateData: null,
+      notUpdating: true,
+      disabled: false,
+      searchDef: {
+        show: false
+      },
+      currentRow: null,
+      timer: '',
+      dismissSecs: 3,
+      sucessCountDown: 0,
+      errorCountDown: 0
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.allPackages
+    ])
+  },
+  methods: {
+    ...mapActions([
+      actionTypes.FETCH_PACKAGES
+    ]),
+    showPackage (item) {
+      this.$router.push({
+        name: 'analysis',
+        params: {
+          package: item
+        }
+      })
+    },
+    updateTable () {
+      this.notUpdating = false
+      this.fetchPackages().then(async response => {
+        this.showAlert(response)
+        setTimeout(() => {
+          this.notUpdating = true
+        }, 1000)
+      })
+      this.updateData = moment().calendar()
+    },
+    updateAnimation () {
+      this.notUpdating = true
+      setTimeout(function () { console.log(this.notUpdating) }, 3000)
+    },
+    successCountDownChanged (sucessCountDown) {
+      this.sucessCountDown = sucessCountDown
+    },
+    errorCountDownChanged (errorCountDown) {
+      this.errorCountDown = errorCountDown
+    },
+    showAlert (sucessMessage) {
+      if (sucessMessage === true) {
+        this.sucessCountDown = this.dismissSecs
+      } else {
+        this.errorCountDown = this.dismissSecs
+      }
+    }
+  },
+  created () {
+    this.updateTable()
+    this.timer = setInterval(this.updateTable, 10000)
+  },
+  beforeDestroy () {
+    clearInterval(this.timer)
+  }
+}
+
+</script>
+
+<style scoped>
+
+.date {
+  font-size: 12px;
+}
+
+.list-pkgs {
+  position: relative;
+  top: 50px;
+}
+
+.table-meta-data {
+  margin-bottom: 20px;
+}
+
+</style>
diff --git a/src/components/package/Search.vue b/src/components/package/Search.vue
new file mode 100644
index 0000000..f6098f1
--- /dev/null
+++ b/src/components/package/Search.vue
@@ -0,0 +1,139 @@
+<template>
+  <div class="search-wrapper">
+    <div class="row">
+      <div class="text-center col-md-12">
+        <h1>Find Packages</h1>
+      </div>
+    </div>
+    <div class="row">
+      <div class="text-center col-md-12">
+        <h4>2 new packages recently added</h4>
+      </div>
+    </div>
+    <div class="row">
+        <div class="col-md-3"></div>
+        <div class="col-md-6 text-center">
+          <div class="wrapper">
+            <input v-model="term" placeholder="Find packages..." type="text" />
+            <a href="">
+              <icon class="search-icon" name="search" scale="1.5"></icon>
+            </a>
+          </div>
+        </div>
+    </div>
+  </div>
+</template>
+
+<script>
+import { mapActions, mapGetters } from 'vuex'
+import * as actionTypes from '../../store/actionTypes.js'
+import * as getterNames from '../../store/getterNames.js'
+
+export default {
+  data () {
+    return {
+      term: '',
+      searchDef: {
+        show: false
+      },
+      currentRow: null
+    }
+  },
+  computed: {
+    ...mapGetters([
+      getterNames.allPackages
+    ])
+  },
+  watch: {
+    term: function (val, oldVal) {
+      console.log(val)
+      this.fetchPackages(val)
+    }
+  },
+  methods: {
+    ...mapActions([
+      actionTypes.FETCH_PACKAGES
+    ]),
+    showPackage () {
+      // show the analysis here
+    }
+  },
+  created () {
+    this.fetchPackages(this.term)
+  }
+}
+
+</script>
+
+<style scoped>
+
+@media only screen and (max-width : 767px) {
+  .search-icon {
+    margin-left: -35px!important;
+  }
+}
+
+@media only screen and (max-width : 480px) {
+  .search-icon {
+    margin-left: 150px!important;
+  }
+}
+
+.search-wrapper {
+  /*background-image: url('/static/grey.jpg');*/
+  background-size: cover;
+  background-color: #eee;
+  min-height: 200px;
+ }
+
+h1 {
+  margin-top: 30px;
+  text-transform: uppercase;
+  font-size: 4em;
+  line-height: 1;
+  font-weight: 200;
+}
+
+h4 {
+  margin: 5px 0;
+  font-size: 1.3em;
+  font-weight: 300;
+  color: #2066AC;
+}
+
+.wrapper {
+  position: relative;
+  padding:0;
+  margin-bottom: 30px;
+ }
+
+.search-icon {
+  position: absolute;
+  font-size: 40px;
+  line-height: 30px;
+  margin-left: -35px;
+  top: 30px;
+  }
+
+  a {
+   text-decoration: none;
+  }
+
+  a:visited {
+   color: black;
+ }
+
+  input {
+    margin-top: 20px;
+    padding: 8px 5px;
+    width: 400px;
+    font-size: 1.2em;
+    line-height: 30px;
+  }
+
+ input:focus {
+   border-color: rgb(31, 48, 90);
+   box-shadow: inset 0 1px 1px rgba(0, 0, 0, 0.075), 0 0 8px rgba(31, 48, 90, 0.6);
+ }
+
+</style>
diff --git a/src/components/shared/HeaderK.vue b/src/components/shared/HeaderK.vue
index 1062feb..15fca79 100644
--- a/src/components/shared/HeaderK.vue
+++ b/src/components/shared/HeaderK.vue
@@ -2,7 +2,7 @@
   <b-navbar toggleable="md" type="dark" variant="dark" class="navbar">
     <b-nav-toggle target="nav_text_collapse" />
     <b-navbar-brand href="home" class="logo">
-      <img src="../../assets/kiskadee_logo.png" width="35" height="35" class="d-inline-block align-top" alt="logo">
+      <img src="../../assets/kiskadee-logo.png" width="35" height="35" class="d-inline-block align-top" alt="logo">
       <router-link :to="{ name: 'home' }">
         <h2 class="name">{{ say_my_name }}</h2>
       </router-link>
@@ -42,7 +42,8 @@ a:link, a:visited {
 
 .name {
   display: inline-block;
-  marging-top: 10px;
+  padding-top: 2px;
+  padding-left: 2px;
 }
 
 .name:hover {
@@ -50,7 +51,7 @@ a:link, a:visited {
 }
 
 .logo {
-  padding-top: 15px;
+  padding-top: 13px;
   text-decoration: none !important;
 }
 </style>
diff --git a/src/main.js b/src/main.js
index 668d5fd..ce518c8 100644
--- a/src/main.js
+++ b/src/main.js
@@ -1,44 +1,30 @@
+// Vue Config
 import Vue from 'vue'
 import App from './App'
-
 import VueRouter from 'vue-router'
-import { routes } from './router/routes'
-import store from './store'
 
-import DataTables from 'vue-data-tables'
-import ElementUI from 'element-ui'
-import 'element-ui/lib/theme-default/index.css'
-import lang from 'element-ui/lib/locale/lang/en'
-import locale from 'element-ui/lib/locale'
-import BootstrapVue from 'bootstrap-vue'
-
-locale.use(lang)
+// Vuex Setup
+import store from './store'
 
-Vue.use(ElementUI)
-Vue.use(DataTables)
-import VueMaterial from 'vue-material'
-Vue.use(VueMaterial)
+// Router Setup
+import { routes } from './router/routes'
 
+// Library Imports
+import 'vue-awesome/icons'
+import Icon from 'vue-awesome/components/Icon'
+import BootstrapVue from 'bootstrap-vue'
 import 'bootstrap/dist/css/bootstrap.css'
 import 'bootstrap-vue/dist/bootstrap-vue.css'
 
-Vue.use(BootstrapVue)
-
+// Plugin Setup
 Vue.use(VueRouter)
-
-Vue.material.registerTheme('default', {
-  primary: {
-    color: 'teal',
-    hue: '500'
-  },
-  accent: 'black',
-  warn: 'black',
-  background: 'white'
-})
+Vue.use(BootstrapVue)
+Vue.component('icon', Icon)
 
 Vue.config.productionTip = false
 /* eslint-disable no-new */
 
+// Configure Router
 const router = new VueRouter({
   routes: routes
 })
diff --git a/src/store/actionTypes.js b/src/store/actionTypes.js
index 3fc18bc..3cbf87c 100644
--- a/src/store/actionTypes.js
+++ b/src/store/actionTypes.js
@@ -1,5 +1,4 @@
 // Packages
 export const FETCH_PACKAGES = 'fetchPackages'
-
-// Analysis
 export const SET_SELECTED = 'setSelected'
+export const FILTERED_PACKAGES = 'filteredPackages'
diff --git a/src/store/getterNames.js b/src/store/getterNames.js
index 105c853..2ffb321 100644
--- a/src/store/getterNames.js
+++ b/src/store/getterNames.js
@@ -1,7 +1,6 @@
 // Packages
 export const allPackages = 'allPackages'
-
-// Analysis
 export const analizers = 'analizers'
 export const reports = 'reports'
 export const errorsList = 'errorsList'
+export const filteredPackages = 'filteredPackages'
diff --git a/src/store/modules/packages.js b/src/store/modules/packages.js
index 3253825..1bd03b2 100644
--- a/src/store/modules/packages.js
+++ b/src/store/modules/packages.js
@@ -3,49 +3,141 @@ import * as actionTypes from '../actionTypes'
 import * as getterNames from '../getterNames'
 import * as mutationTypes from '../mutationsTypes'
 
+// const mockedPackages = [
+//   {
+//     name: 'example1',
+//     last_version: '0.1'
+//   },
+//   {
+//     name: 'foo1',
+//     last_version: '0.2'
+//   },
+//   {
+//     name: 'example2',
+//     last_version: '0.3'
+//   }
+// ]
+
+const mockedPackages = [
+  {
+    name: 'Fedora Package',
+    version: '0.3.8',
+    upstream: 'http://www.google.com',
+    lastUpdate: '17/09/2017',
+    last_version: '0.1',
+    versions: [
+      {analysis: [
+        {analyzer_id: '2'}
+      ],
+        number: '2',
+        package_id: '1'
+      }
+    ]
+  },
+  {
+    name: 'Pacote de Dados',
+    version: '0.3.8',
+    upstream: 'http://www.google.com',
+    lastUpdate: '17/09/2017',
+    last_version: '0.2',
+    versions: [
+      {analysis: [
+        {analyzer_id: '3'}
+      ],
+        number: '2',
+        package_id: '1'
+      }
+    ]
+  },
+  {
+    name: 'Teste',
+    version: '0.3.8',
+    upstream: 'http://www.google.com',
+    lastUpdate: '17/09/2017',
+    last_version: '0.3',
+    versions: [
+      {analysis: [
+        {analyzer_id: '1'}
+      ],
+        number: '2',
+        package_id: '1'
+      }
+    ]
+  }
+]
+
 const state = {
-  allPackages: [
-    {
-      name: 'Teste',
-      version: '1.0.1',
-      upstream: 'http://www.google.com',
-      lastUpdate: '17/09/2017'
-    },
-    {
-      name: 'Pacote de dados',
-      version: '1.0.2',
-      upstream: 'http://www.google.com',
-      lastUpdate: '17/09/2017'
-    },
-    {
-      name: 'Fedora Package',
-      version: '0.3.8',
-      upstream: 'http://www.google.com',
-      lastUpdate: '17/09/2017'
-    }
-  ]
+  allPackages: mockedPackages,
+  filteredPackages: {}
 }
 
 const getters = {
   [getterNames.allPackages]: (state) => {
     return state.allPackages
+  },
+  [getterNames.filteredPackages]: (state) => {
+    return state.filteredPackages
   }
 }
 
 const actions = {
-  async [actionTypes.FETCH_PACKAGES] ({commit, getters, state}) {
+  async [actionTypes.FETCH_PACKAGES] ({commit, getters, state}, search) {
     // let { data } = await api.get()
-    // commit(mutationTypes.STORE_PACKAGES, data)
+    console.log(`action: ${search}`)
+    let data = []
+    if (!search) {
+      data = mockedPackages
+    } else {
+      data = mockedPackages.filter((pkg) => {
+        return pkg.name.includes(search)
+      })
+    }
+    commit(mutationTypes.STORE_PACKAGES, data)
+
+    if (data.length === 0) {
+      return false
+    } else {
+      return true
+    }
+  },
+  async [actionTypes.FILTERED_PACKAGES] ({commit, getters, state}, search) {
+    commit(mutationTypes.FILTER_PACKAGES, search)
   }
 }
 
 const mutations = {
   [mutationTypes.STORE_PACKAGES] (state, data) {
-    state.allPackages = data.packages.map((pkg) => {
+    state.allPackages = data.map((pkg) => {
+      return {
+        package_id: pkg.versions[0].package_id,
+        name: pkg.name,
+
+        last_version: pkg.versions[0].number,
+        fetcher_id: pkg.fetcher_id,
+        analyzer_id: pkg.versions[0].analysis[0].analyzer_id
+      }
+    })
+  },
+  [mutationTypes.FILTER_PACKAGES] (state, search) {
+    state.filtered = state.allPackages.map((pkg) => {
+      return {
+        name: pkg.name,
+        last_version: pkg.last_version
+      }
+    }).filter((pkg) => {
+      return pkg.name.includes(search)
+    })
+  },
+  [mutationTypes.FILTER_PACKAGES] (state, search) {
+    state.filtered = state.allPackages.map((pkg) => {
       return {
         name: pkg.name,
-        lastVersion: pkg.versions[0].number
+        last_version: pkg.last_version,
+        fetcher_id: pkg.fetcher_id,
+        analyzer_id: pkg.versions[0].analysis[0].analyzer_id
       }
+    }).filter((pkg) => {
+      return pkg.name.includes(search)
     })
   }
 }
diff --git a/src/store/mutationsTypes.js b/src/store/mutationsTypes.js
index 123b673..f2ba8b2 100644
--- a/src/store/mutationsTypes.js
+++ b/src/store/mutationsTypes.js
@@ -1,5 +1,4 @@
 // Packages
 export const STORE_PACKAGES = 'STORE_PACKAGES'
-
-// Analysis
 export const STORE_SELECTED = 'STORE_SELECTED'
+export const FILTER_PACKAGES = 'FILTER_PACKAGES'
